﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Windows.Forms;
using HeuristicLab.Collections;
using HeuristicLab.Core;
using HeuristicLab.Core.Views;
using HeuristicLab.MainForm;
using HeuristicLab.MainForm.WindowsForms;

namespace HeuristicLab.Clients.Access.Views {

  [View("LightweightUser View")]
  [Content(typeof(ReadOnlyCheckedItemList<LightweightUser>), true)]
  public partial class LightweightUserView : CheckedItemListView<LightweightUser> {
    public LightweightUserView() {
      InitializeComponent();
      this.showDetailsCheckBox.Checked = false;
      this.itemsGroupBox.Text = "Users";
    }

    protected override void SetEnabledStateOfControls() {
      base.SetEnabledStateOfControls();
      this.showDetailsCheckBox.Enabled = false;
    }

    protected override void Content_CheckedItemsChanged(object sender, CollectionItemsChangedEventArgs<IndexedItem<LightweightUser>> e) {
      base.Content_CheckedItemsChanged(sender, e);
      OnSelectedUsersChanged();
    }

    public event EventHandler SelectedUsersChanged;
    protected virtual void OnSelectedUsersChanged() {
      if (InvokeRequired)
        Invoke((MethodInvoker)OnSelectedUsersChanged);
      else {
        EventHandler handler = SelectedUsersChanged;
        if (handler != null)
          handler(this, EventArgs.Empty);
      }
    }
  }
}
